/*

            ^OtBNX\

        Copyright 2009-2011 , Yoshi Hiroshi.

 */

#include <avr/io.h>
#include <avr/eeprom.h>
#include <avr/pgmspace.h>
#include <util/delay.h>
#include <stdio.h>
#include <string.h>
#include <math.h>

void readImage();
void dispImageAt(int x, int y, int rX, int dS);

void readTragiData();
void scrollTragiLogo();
void showMaikohan();

int par80PutByte(char c, FILE *stream);
FILE par80 = FDEV_SETUP_STREAM(par80PutByte, 0, _FDEV_SETUP_RW);

void par80Init()
{
    DDRB = 0xFF;
    DDRD = 0x60;
    PORTD = 0x20;   // WR:HIGH
    stdout = &par80;
    _delay_ms(1);
}

int par80PutByte(char c, FILE *stream)   // 1oCg̓]
{
    loop_until_bit_is_set(PIND, PD7);
    PORTB = c;
    PORTD &= ~_BV(PD5); // WR LOW
    PORTD |= _BV(PD5);  // WR HIGH
    //_delay_ms(100);
    return 0;
}

void ledPort(char val)
{
    printf("\37(p\20\1");    // PORT 1 OUT
    putchar(val);
}

void printAt(int x, int y, char* str)
{
    printf("\37(d\60");         // dotw蕶\
    putchar(x & 0xFF);putchar(x >> 8);
    putchar(y);putchar(0);
    putchar(0);
    putchar(strlen(str));
    printf(str);
}

// col: 0:OFF, 1:ON
void drawDot(char col, int x, int y)
{
    printf("\37(d\20");
    putchar(col);
    putchar(x & 0xFF);putchar(x >> 8);
    putchar(y);putchar(0);
}

// type: 0;line, 1:box, 2:boxFill
// col: 0:OFF, 1:ON
void drawLine(char type, char col, int sx, int sy, int ex, int ey)
{
    printf("\37(d\21");         // C`
    putchar(type);              // type
    putchar(col);                 // pen ON
    putchar(sx & 0xFF);putchar(sx >> 8);      // start X
    putchar(sy);putchar(0);     // start Y
    putchar(ex & 0xFF);putchar(ex >> 8);      // end X
    putchar(ey);putchar(0);     // end Y
}

int main()
{
    CLKPR = _BV(CLKPCE);
    CLKPR = 0;
    par80Init();
    printf("\37(p\1\1\377");    // PORT 1 DDR
    printf("\37(w\20\1");       // ʃ[hFS
    printf("\37(g\2\1");        // 2@byte mode ON
    //readTragiData();
    readImage();

    while(1) {

// ʂP
        printf("\14");              // CLEAR
        //scrollTragiLogo();
        _delay_ms(1000);

// ʂQ
        //printf("\14");              // CLEAR
        //showMaikohan();

        dispImageAt(0, 0, 0, 512);
        _delay_ms(2000);
        printf("\37(a\20");putchar(8);putchar(0);putchar(0);putchar(2);putchar(1);
        _delay_ms(5000);
        _delay_ms(5000);
    }
}

unsigned char imageData[] PROGMEM =
{
// SIZE:W:256, H:64
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  0x00,0x00,0x00,0xFF,0xFC,0x00,0x00,0x00,  0x00,0x00,0x07,0xFF,0xFF,0x80,0x00,0x00,
0x00,0x00,0x1F,0xFF,0xFF,0xE0,0x00,0x00,  0x00,0x00,0x7F,0xFF,0xFF,0xF8,0x00,0x00,  0x00,0x00,0xFF,0xFF,0xFF,0xFC,0x00,0x00,  0x00,0x03,0xBF,0xBF,0xFF,0xFF,0x00,0x00,
0x00,0x07,0xBF,0xBF,0xFF,0xFF,0x80,0x00,  0x00,0x1F,0xBF,0xBF,0xFF,0xFF,0xE0,0x00,  0x00,0x38,0x00,0x0F,0xFF,0xFF,0xF0,0x00,  0x00,0x78,0x00,0x0F,0xFF,0xFF,0xF8,0x00,
0x00,0xF8,0x00,0x0F,0xFF,0xFF,0xFC,0x00,  0x00,0xF8,0x00,0x0F,0xFF,0xFF,0xFC,0x00,  0x01,0xFF,0xFF,0xFF,0xFF,0xFF,0xFE,0x00,  0x03,0xF8,0x00,0x1F,0xFF,0xFF,0x93,0x00,
0x03,0xF8,0x00,0x0F,0xFF,0xFF,0x03,0x00,  0x07,0xF8,0x00,0x0F,0xFF,0xFE,0x73,0x80,  0x0F,0xF8,0x00,0x0F,0xFF,0xFE,0x7F,0xC0,  0x0F,0xFC,0x0F,0xEF,0xFF,0xFC,0x3F,0xC0,
0x1F,0xFC,0x1F,0xEF,0xFF,0xE0,0x3F,0xE0,  0x1F,0xFC,0x3F,0xEF,0xFF,0x00,0x1F,0xE0,  0x1F,0x7D,0xFF,0xF7,0xFF,0xC0,0x07,0xE0,  0x3E,0x3F,0xFF,0x33,0xE3,0xE0,0x03,0xF0,
0x3F,0x7F,0xFF,0x00,0xC3,0xF0,0x07,0xF0,  0x3F,0xFF,0xFF,0x88,0x03,0xF8,0x1F,0xF0,  0x3F,0xFF,0xFF,0xCC,0x0F,0xFC,0x3F,0xF0,  0x3F,0xFF,0xFF,0x80,0x07,0xFC,0x3F,0xF0,
0x37,0xFF,0xFF,0x00,0x07,0xFC,0x7F,0xF0,  0x23,0xFF,0xFF,0x00,0x07,0xFD,0x7F,0xF0,  0x77,0xFF,0xFF,0x20,0x07,0xFF,0xFF,0xF0,  0x3F,0xFF,0xFF,0xA0,0x07,0xFF,0xFF,0xF0,
0x3F,0xFF,0xFF,0xA0,0x07,0xFF,0xFF,0xF0,  0x3F,0xFF,0xFF,0xA0,0x05,0xFF,0xFF,0xF0,  0x3F,0xFD,0xFF,0xA0,0x01,0xFF,0xFF,0xF0,  0x3F,0xF8,0xFF,0xA0,0x01,0xFF,0xFF,0xF0,
0x3F,0xFD,0xFF,0xA0,0x01,0xFF,0xFF,0xF0,  0x3F,0x7F,0xFF,0xB0,0x03,0xFF,0xFF,0xF0,  0x3E,0x3F,0xFF,0xFE,0xFB,0xFD,0xFF,0xF0,  0x1F,0x7F,0xEF,0xFF,0xBB,0xFC,0xFF,0xE0,
0x1F,0xFF,0xC7,0xFF,0x80,0x00,0xFF,0xE0,  0x1F,0xFF,0xEF,0xFF,0x80,0x00,0xFF,0xE0,  0x0F,0xFF,0xFF,0xFF,0xC8,0x00,0xFF,0xC0,  0x0F,0xFF,0xFF,0xFF,0xE8,0x01,0xFF,0xC0,
0x07,0xFF,0xFF,0xFF,0xA8,0x00,0xFF,0x80,  0x03,0xFF,0xFF,0xFF,0x88,0x02,0xFF,0x00,  0x03,0xFF,0xFF,0xFF,0x98,0x02,0xFF,0x00,  0x01,0xFF,0xFF,0xFF,0x83,0x6A,0xFE,0x00,
0x00,0xFF,0xFE,0xFF,0xA3,0x6A,0xFC,0x00,  0x00,0xFF,0xFC,0x7F,0xC3,0x6A,0xFC,0x00,  0x00,0x7F,0xFE,0xFF,0x88,0x02,0xF8,0x00,  0x00,0x3F,0xFF,0xFF,0x88,0x02,0xF0,0x00,
0x00,0x1F,0xFF,0xFF,0xA8,0x02,0xE0,0x00,  0x00,0x07,0xFF,0xFF,0xEC,0x02,0x80,0x00,  0x00,0x03,0xFF,0xFF,0xFF,0xFE,0x00,0x00,  0x00,0x00,0xFF,0xFF,0xFF,0xFC,0x00,0x00,
0x00,0x00,0x7F,0xDF,0xFF,0xF8,0x00,0x00,  0x00,0x00,0x1F,0x8F,0xFF,0xE0,0x00,0x00,  0x00,0x00,0x07,0xDF,0xFF,0x80,0x00,0x00,  0x00,0x00,0x00,0xFF,0xFC,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x1E,0x00,0x00,0x00,0x00,0x00,  0x00,0x00,0x1F,0xFF,0xFF,0xFF,0xF0,0x00,  0x00,0x1E,0x1F,0xFF,0xFF,0xFF,0xFC,0x00,  0x00,0x1F,0x1F,0xFF,0xFF,0xFF,0xFE,0x00,
0x00,0x1F,0x1F,0xFF,0xFF,0xFF,0xFF,0x00,  0x00,0x1F,0x9F,0xFF,0xFF,0xFF,0xFF,0x80,  0x00,0x1F,0x8F,0xFF,0xFF,0xFF,0xFF,0x80,  0x00,0x3F,0x87,0xFF,0xFF,0xFF,0xFF,0xC0,
0x00,0x3F,0x83,0xFF,0xFF,0xFF,0xFF,0xC0,  0x00,0x3F,0x80,0x7F,0xFF,0xFF,0xFF,0xE0,  0x00,0x3F,0x80,0xFE,0x7F,0xFC,0xFF,0xE0,  0x00,0x7F,0x80,0xFE,0xFF,0xFC,0x0F,0xF0,
0x00,0x7F,0x80,0xFF,0xFF,0xFC,0x0F,0xF0,  0x00,0x7F,0x80,0xFF,0xFF,0xFE,0x0F,0xF0,  0x00,0xFF,0x80,0xFF,0xFB,0xFF,0x1F,0xF0,  0x00,0xFF,0x98,0xFF,0xE7,0xFF,0x9F,0xF0,
0x00,0xFF,0xBC,0xFF,0xEF,0xFF,0xFF,0xF0,  0x01,0xFF,0xBE,0xFF,0xDF,0xFF,0xFF,0xF0,  0x01,0xFF,0x7E,0x7F,0xBF,0xFF,0xFF,0xF0,  0x01,0xFF,0x7E,0x7F,0xFF,0xFF,0xFF,0xE0,
0x03,0xFF,0x7F,0x7F,0xFF,0xEF,0xFF,0xE0,  0x03,0xFE,0x7F,0xBF,0xFF,0x8F,0xFF,0xE0,  0x03,0xFE,0x7F,0xFF,0xFE,0x1F,0xFF,0xE0,  0x03,0xFE,0xFF,0xFF,0xFF,0xFF,0xFF,0xC0,
0x07,0xFC,0xFF,0xFF,0xFF,0xFF,0xFF,0xC0,  0x07,0xFD,0xFF,0xFF,0xFF,0xFF,0xFF,0xC0,  0x07,0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0x80,  0x07,0xFB,0xFF,0xFF,0xFF,0xFF,0xFF,0xC0,
0x07,0xFB,0xFF,0xFF,0xFF,0xFF,0xFF,0xE0,  0x07,0xF3,0xFF,0xFF,0xFF,0xFF,0xFF,0xE0,  0x07,0xF7,0xFF,0xFF,0xFF,0xFF,0xFF,0xF0,  0x07,0xF7,0xFF,0xFF,0xFF,0xFF,0xFF,0xF0,
0x07,0xFF,0xFB,0xFF,0xFF,0xFF,0xFF,0xF8,  0x07,0xEF,0xF3,0xFB,0xFF,0xFF,0xFF,0xF8,  0x07,0xFF,0xF3,0xF3,0xFF,0x8F,0xFF,0xF8,  0x07,0xFF,0xF7,0xE7,0xFF,0xCF,0xFD,0xFC,
0x07,0xFF,0xE7,0xEF,0xFF,0xFF,0xFD,0xFC,  0x07,0xFF,0xE7,0xFF,0xFF,0xFF,0xFD,0xFC,  0x07,0xFF,0xE7,0xFF,0xFF,0xFF,0xFD,0xFC,  0x03,0xFF,0xC7,0xFF,0xFF,0xFF,0xF9,0xFE,
0x03,0xFF,0xC7,0xFF,0xFF,0xFF,0xF9,0xFE,  0x03,0xFF,0xC7,0xFF,0xFF,0xFF,0xF9,0xFE,  0x01,0xFF,0xFB,0xFF,0xEF,0xFF,0xF9,0xFE,  0x00,0xFF,0xFF,0xFF,0xE7,0xFF,0xF9,0xFE,
0x00,0xFF,0xFF,0xFF,0xC3,0xFF,0xF9,0xFE,  0x00,0x3F,0xFE,0xFF,0x81,0xFF,0xFB,0xFE,  0x00,0x01,0xFF,0xFF,0xFF,0xFF,0xFF,0xFE,  0x00,0x01,0xFF,0xFF,0xFF,0xFF,0xFF,0xFE,
0x00,0x01,0xFF,0xFF,0xFF,0xFF,0xFF,0xFE,  0x00,0x01,0xFF,0xFF,0xFF,0xFF,0xFF,0xFE,  0x00,0x00,0xFF,0xFF,0xFF,0xFF,0xFF,0xFC,  0x00,0x00,0xFF,0xFF,0xFF,0xFF,0xFF,0xFC,
0x00,0x00,0x7F,0xFF,0xFF,0xFF,0xFF,0xFC,  0x00,0x00,0x3F,0xFF,0xFF,0xFF,0xFF,0xF8,  0x00,0x00,0x0F,0xFF,0xFF,0xFF,0xFF,0xF8,  0x00,0x00,0x03,0xFF,0xFF,0xFF,0xFF,0xE0,
0x00,0x00,0x00,0x01,0xFF,0x3F,0xFF,0x80,  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  0x00,0x00,0x7C,0x00,0x00,0x00,0x00,0x00,  0x00,0x00,0xFF,0x00,0x00,0x00,0x00,0x00,  0x00,0x01,0xFF,0x80,0x00,0x00,0x00,0x00,
0x00,0x03,0xFF,0x80,0xE0,0x0F,0xFF,0x00,  0x00,0x07,0xFF,0xF3,0xFF,0xFF,0xFF,0xC0,  0x00,0x0F,0xFF,0xFB,0xFF,0xFF,0xFF,0xE0,  0x00,0x1F,0xFF,0xFF,0xFF,0xFF,0xFF,0xF0,
0x00,0x3F,0xFF,0xFF,0xFF,0xFF,0xFF,0xF8,  0x00,0x7F,0xFF,0xFF,0xFF,0xFF,0xFF,0xF8,  0x00,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFC,  0x1F,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFC,
0x3F,0xFF,0xFB,0xFF,0xFF,0xFF,0xFF,0xFC,  0x3F,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFC,  0x3F,0xFF,0xFF,0xFF,0xE7,0xF9,0xFF,0xFC,  0x3F,0xFF,0xFF,0xFF,0xF7,0xFF,0xFF,0xFC,
0x3F,0xFF,0xFF,0xFF,0xF7,0xFF,0xFF,0xFC,  0x3F,0xFF,0xFF,0xFF,0xF7,0xFF,0xFF,0xF8,  0x3F,0xFF,0xFF,0xFF,0xF7,0xFF,0xFF,0xF0,  0x3F,0xFE,0xFF,0xEF,0xFF,0xFF,0xFF,0x80,
0x1F,0xFF,0xFF,0xE7,0xFF,0xFF,0x80,0x00,  0x0F,0xFF,0xFF,0xC3,0xFF,0xFE,0x01,0xE0,  0x07,0xFF,0xBF,0xFF,0xFF,0xFF,0xFF,0xF0,  0x01,0xFF,0xCF,0xFF,0xFF,0xFF,0xFF,0xF8,
0x01,0xFF,0xEF,0xFF,0xFF,0xFF,0xFF,0xF8,  0x00,0xFF,0xEF,0xFF,0xFF,0xFF,0xFF,0xF8,  0x00,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xF8,  0x00,0x7F,0xFF,0xFF,0xFF,0xEF,0xFF,0xF8,
0x00,0x7F,0xFB,0xFF,0xFF,0xE7,0xFF,0xF0,  0x00,0x3F,0xF9,0xFF,0xFF,0xE1,0xFF,0xF0,  0x00,0x3F,0xF8,0x7F,0xE3,0x80,0x7F,0xC0,  0x00,0x1F,0xFF,0xF0,0x00,0x00,0x00,0x00,
0x00,0x3F,0xFF,0xF8,0x00,0x00,0x00,0x00,  0x00,0x3F,0xFF,0xF8,0x0F,0xFF,0xFC,0x00,  0x00,0x3F,0xFF,0xFF,0xFF,0xFF,0xFF,0x80,  0x03,0x1F,0xFF,0xFF,0xFF,0xFF,0xFF,0xE0,
0x07,0x9F,0xFF,0xFF,0xFF,0xFF,0xFF,0xF0,  0x0F,0xCF,0xFF,0xFF,0xFF,0xFF,0xFF,0xF8,  0x0F,0xE3,0xF8,0xFF,0xFF,0xFF,0xFF,0xF8,  0x0F,0xF7,0xF8,0xFF,0xFF,0xFF,0xFF,0xFC,
0x0F,0xFF,0xF8,0xFF,0xFF,0xFF,0xFF,0xFC,  0x0F,0xFF,0xF9,0xFF,0xFF,0xFF,0xFF,0xFC,  0x0F,0xFF,0xF9,0xFF,0x3F,0xCF,0xE7,0xF8,  0x0F,0xFF,0xF3,0xFE,0x3F,0xDF,0xE7,0xF8,
0x0F,0xFF,0xF3,0xFE,0x7F,0xDF,0xE7,0xF8,  0x0F,0xFF,0xE7,0xFE,0x7F,0xBF,0xE7,0xF8,  0x07,0xFF,0xE7,0xFC,0x7F,0xBF,0xEF,0xF8,  0x07,0xFF,0xCF,0xF8,0xFF,0x3F,0xCF,0xF8,
0x03,0xFF,0x8F,0xF3,0xFF,0x3F,0xDF,0xF0,  0x01,0xFF,0x1F,0xE7,0xFF,0x3F,0x9F,0xF0,  0x00,0xFE,0x7F,0xFF,0xFE,0x3F,0xFF,0xF0,  0x00,0xFC,0xFF,0xFF,0xFE,0x3F,0xFF,0xF0,
0x00,0xFF,0xFF,0xFF,0xFE,0x3F,0xFF,0xF0,  0x00,0xFF,0xFF,0xFF,0xFE,0x3F,0xFF,0xF8,  0x00,0xFF,0xFF,0xFF,0xFE,0x3F,0xFF,0xF8,  0x00,0xFF,0xFF,0xFF,0xFE,0x3F,0xFF,0xF8,
0x00,0x7F,0xFF,0xFF,0xFE,0x3F,0xFF,0xF8,  0x00,0x7F,0xFF,0xFF,0xFE,0x1F,0xFF,0xF8,  0x00,0x3F,0xFE,0x7F,0x80,0x0F,0xFF,0xF0,  0x00,0x1F,0xF8,0x18,0x00,0x07,0xFC,0xC0,
0x00,0x07,0xF0,0x00,0x00,0x01,0xF0,0x00,  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  0x00,0x00,0x00,0x00,0x07,0x03,0xF0,0x00,  0x30,0x00,0x00,0x03,0x0F,0x8F,0xF8,0x00,  0x00,0x00,0x00,0x07,0xFF,0xFF,0xFF,0xF0,
0x00,0x86,0x20,0x07,0xFF,0xFF,0xFF,0xF8,  0x00,0x00,0x00,0x07,0xFF,0xFF,0xFF,0xFC,  0x40,0x00,0x00,0x07,0xFF,0xFF,0xFF,0xFC,  0x00,0x00,0x1C,0x07,0xFF,0xFF,0xFF,0xF8,
0x01,0xC0,0x63,0x03,0xFB,0xFF,0x9F,0xF8,  0x06,0x30,0x80,0x81,0xF1,0xFE,0x03,0x00,  0x08,0x09,0x00,0x40,0x00,0x18,0x03,0x00,  0x10,0x06,0x00,0x20,0x30,0x1C,0x03,0x80,
0x10,0x06,0x00,0x20,0x38,0x1E,0x01,0x80,  0x23,0x22,0x00,0x10,0x3C,0x1E,0x01,0xC0,  0x23,0x26,0x00,0x10,0x7C,0x3E,0x01,0xC0,  0x20,0x26,0x42,0x10,0x7C,0x3E,0x01,0xE0,
0x20,0x26,0xE7,0x10,0xFC,0x7E,0x00,0xE0,  0x20,0x26,0x42,0x10,0xFC,0x7E,0x00,0xF0,  0x23,0x26,0x00,0x11,0xFC,0xFC,0x00,0xF0,  0x23,0x24,0x00,0x11,0xF8,0xFC,0x00,0xF8,
0x10,0x06,0x00,0x23,0xF8,0xFC,0x00,0x78,  0x10,0x06,0x00,0x23,0xF9,0xF8,0x00,0x78,  0x08,0x09,0x00,0x43,0xF1,0xFC,0x07,0xF8,  0x06,0x30,0x80,0x87,0xF1,0xFF,0xFF,0xF8,
0x01,0xC0,0x63,0x07,0xE1,0xFF,0xFF,0xFC,  0x00,0x00,0x1C,0x07,0xE3,0xFF,0xFF,0xFC,  0x60,0x00,0x00,0x03,0xF3,0xFF,0xFF,0xFC,  0x00,0x0C,0x60,0x03,0xF3,0xFF,0xFF,0xF8,
0x06,0x00,0x00,0x03,0xF3,0xFF,0xFF,0xF8,  0x00,0x00,0x00,0x03,0xF1,0xFF,0xFF,0xF0,  0x00,0x00,0x00,0x01,0xF1,0xF8,0x00,0x00,  0x00,0x40,0x00,0x00,0xE1,0xF8,0x00,0x00,
0x18,0x00,0x00,0x00,0x00,0xF8,0x00,0x00,  0x00,0x00,0x00,0x00,0x00,0x78,0x00,0x00,  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,

// SIZE:W:256, H:64
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  0x00,0x00,0x00,0x00,0x00,0x0F,0xE0,0x00,  0x00,0x00,0x00,0x00,0x00,0x04,0x10,0x00,  0x00,0x00,0x00,0x00,0x00,0x12,0x0C,0x00,
0x00,0x00,0x00,0x00,0x00,0x11,0x82,0x00,  0x00,0x00,0x00,0x00,0x00,0x20,0x41,0x00,  0x00,0x00,0x00,0x00,0x00,0x20,0x20,0x80,  0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x40,
0x00,0x00,0x00,0x00,0x01,0xF2,0x28,0x30,  0x00,0x00,0x00,0x00,0x01,0xC2,0x24,0x08,  0x00,0x00,0x00,0x00,0x00,0x42,0x23,0x04,  0x00,0x00,0x00,0x00,0x00,0x42,0x20,0x82,
0x00,0x00,0x00,0x00,0x01,0xFF,0xE0,0x50,  0x00,0x00,0x00,0x00,0x01,0xFF,0xE0,0x3F,  0x00,0x00,0x00,0x00,0x00,0x42,0x20,0x10,  0x00,0x00,0x00,0x00,0x00,0x42,0x20,0x11,
0x00,0x00,0x00,0x00,0x01,0x42,0x20,0x21,  0x00,0x00,0x00,0x00,0x01,0x42,0x20,0x21,  0x00,0x00,0x00,0x00,0x01,0x40,0x20,0x22,  0x00,0x00,0x00,0x00,0x02,0x00,0x00,0x22,
0x00,0x00,0x00,0x00,0x02,0x00,0x00,0x22,  0x00,0x00,0x00,0x00,0x02,0x00,0x00,0x22,  0x00,0x00,0x00,0x00,0x02,0x08,0x00,0x42,  0x00,0x00,0x00,0x00,0x02,0x08,0x00,0x42,
0x00,0x00,0x00,0x00,0x04,0x88,0x00,0x44,  0x00,0x00,0x00,0x00,0x04,0x88,0x20,0x44,  0x00,0x00,0x00,0x00,0x04,0x88,0x60,0x44,  0x00,0x00,0x00,0x00,0x04,0x89,0xC0,0x44,
0x00,0x00,0x00,0x00,0x04,0xFF,0x80,0x84,  0x00,0x00,0x00,0x00,0x04,0xFE,0x00,0x84,  0x00,0x00,0x00,0x00,0x09,0x88,0x00,0x88,  0x00,0x00,0x00,0x00,0x09,0x08,0x00,0x88,
0x00,0x00,0x00,0x00,0x08,0x08,0x00,0x88,  0x00,0x10,0x02,0x00,0x08,0x08,0x00,0x88,  0x00,0x10,0x02,0x00,0x08,0x00,0x01,0x08,  0x00,0x10,0x06,0x00,0x10,0x00,0x01,0x08,
0x00,0x10,0x04,0x00,0x10,0x00,0x01,0x10,  0x00,0x10,0x0C,0x00,0x10,0x00,0x01,0x10,  0x00,0x10,0x08,0x00,0x10,0x00,0x01,0x10,  0x01,0xFF,0xFF,0x80,0x10,0x22,0x41,0x10,
0x01,0xFF,0xFF,0x80,0x20,0x22,0x42,0x10,  0x00,0x00,0x00,0x00,0x20,0x22,0x42,0x10,  0x00,0x00,0x00,0x00,0x20,0x22,0x42,0x20,  0x01,0xFF,0xFF,0x80,0x20,0x22,0x42,0x20,
0x01,0xFF,0xFF,0x80,0x20,0x22,0x42,0x20,  0x00,0x06,0x00,0x80,0x20,0x22,0x42,0x20,  0x00,0x0C,0x00,0x80,0x40,0x3F,0xC4,0x20,  0x00,0x18,0x00,0x80,0x40,0x3F,0xC4,0x20,
0x00,0x18,0x00,0x80,0x40,0x00,0x04,0x40,  0x00,0x30,0x00,0x80,0x40,0x00,0x04,0x40,  0x00,0x30,0x0F,0x80,0x40,0x00,0x04,0x40,  0x00,0x20,0x0F,0x80,0x80,0x00,0x04,0x40,
0x00,0x00,0x00,0x00,0x80,0x00,0x08,0x40,  0x00,0x00,0x00,0x00,0x80,0x40,0x48,0x40,  0x00,0x00,0x00,0x00,0x40,0x40,0x48,0x80,  0x00,0x00,0x00,0x00,0x20,0x40,0x48,0x80,
0x00,0x04,0x00,0xC0,0x10,0x40,0x48,0x80,  0x00,0x86,0x03,0xC0,0x0C,0x40,0x48,0x80,  0x00,0xC7,0x3F,0x80,0x02,0x40,0x50,0x80,  0x00,0xE3,0x3E,0x00,0x01,0x40,0x50,0x80,
0x00,0x71,0x60,0x00,0x00,0xC0,0x51,0x00,  0x00,0x30,0x40,0x00,0x00,0x40,0x51,0x00,  0x00,0xF0,0x7E,0x00,0x00,0x7F,0xD1,0x00,  0x01,0xE7,0xFE,0x00,0x00,0x7F,0xD1,0x00,
0x01,0x8F,0xE2,0x00,0x00,0x0C,0x21,0x00,  0x00,0x88,0x42,0x00,0x00,0x02,0x21,0x00,  0x00,0x88,0x46,0xC0,0x00,0x01,0x22,0x00,  0x00,0x88,0x7E,0xC0,0x00,0x00,0xA2,0x00,
0x00,0x8F,0xFE,0xC0,0x00,0x00,0x7E,0x00,  0x00,0x8F,0xC2,0xC0,0x00,0x00,0x02,0x00,  0x00,0x88,0x42,0xC0,0x00,0x00,0x00,0x00,  0x00,0x88,0x47,0xC0,0x00,0x00,0x00,0x00,
0x00,0x8B,0xFF,0x80,0x00,0x00,0x00,0x00,  0x00,0x8F,0xFE,0x00,0x00,0x00,0x00,0x00,  0x00,0x87,0xC2,0x00,0x00,0x00,0x00,0x00,  0x00,0x80,0x42,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x18,0x00,  0x00,0x00,0x00,0x00,0x00,0x20,0x38,0x00,  0x00,0x00,0x00,0x00,0x00,0x60,0x68,0x00,  0x01,0x02,0x00,0x40,0x00,0x70,0xC8,0x00,
0x01,0x82,0x00,0xC0,0x00,0x58,0x88,0x00,  0x00,0xC2,0x00,0xC0,0x00,0x4F,0x88,0x00,  0x00,0xE3,0xFF,0x80,0x00,0x60,0x08,0x00,  0x00,0x63,0xFF,0x80,0x00,0x20,0x08,0x00,
0x00,0x40,0x01,0x80,0x00,0x20,0x0C,0x00,  0x00,0x47,0xFC,0xC0,0x00,0x30,0x04,0x00,  0x00,0x4F,0xFE,0x40,0x00,0x10,0x04,0x00,  0x01,0xC9,0x12,0x40,0x00,0x08,0x04,0x00,
0x01,0xC9,0x12,0x40,0x00,0x7C,0x0C,0x00,  0x00,0xC9,0x12,0x40,0x00,0x07,0xF0,0x00,  0x00,0x79,0x12,0x40,0x03,0xF9,0xE0,0x00,  0x00,0x79,0x12,0x40,0x06,0x00,0x38,0x00,
0x00,0x49,0x12,0x40,0x04,0x00,0x08,0x00,  0x00,0xC9,0x12,0x40,0x04,0x00,0x08,0x00,  0x01,0xC9,0x12,0x40,0x04,0x00,0x0C,0x00,  0x01,0xC9,0x12,0x40,0x04,0x00,0x04,0x00,
0x00,0x4F,0xFE,0x40,0x04,0x00,0x24,0x00,  0x00,0x47,0xFC,0x40,0x0C,0x30,0x26,0x00,  0x00,0x40,0x00,0x40,0x09,0xF2,0x22,0x00,  0x00,0x00,0x00,0x00,0x09,0xC2,0x22,0x00,
0x00,0x00,0x00,0x00,0x08,0x42,0x22,0x00,  0x00,0x00,0x00,0x00,0x08,0x42,0x22,0x00,  0x00,0x00,0x00,0x00,0x09,0xFF,0xE2,0x00,  0x00,0x03,0xFE,0x00,0x09,0xFF,0xE2,0x00,
0x00,0x0F,0xFF,0x00,0x08,0x42,0x22,0x00,  0x00,0x1E,0x03,0x80,0x08,0x42,0x22,0x00,  0x00,0x38,0x01,0x80,0x08,0x42,0x22,0x00,  0x00,0x30,0x01,0x80,0x08,0x42,0x22,0x00,
0x00,0x60,0x03,0x00,0x08,0x40,0x22,0x00,  0x00,0x60,0x0F,0x00,0x08,0x00,0x02,0x00,  0x00,0x40,0x7C,0x00,0x08,0x00,0x02,0x00,  0x00,0x5F,0xF8,0x00,0x08,0x00,0x02,0x00,
0x00,0x7F,0xC0,0x00,0x08,0x21,0x02,0x00,  0x00,0x78,0x00,0x00,0x08,0x21,0x02,0x00,  0x00,0x60,0x00,0x80,0x08,0x21,0x02,0x00,  0x00,0x60,0x00,0x80,0x08,0x21,0x02,0x00,
0x00,0x30,0x01,0x80,0x09,0xF3,0x02,0x00,  0x00,0x38,0x03,0x80,0x09,0xFF,0xE2,0x00,  0x00,0x1C,0x0F,0x00,0x08,0x2F,0xE2,0x00,  0x00,0x0F,0xFE,0x00,0x08,0x22,0x02,0x00,
0x00,0x03,0xF8,0x00,0x08,0x62,0x02,0x00,  0x00,0x00,0x00,0x00,0x08,0x42,0x02,0x00,  0x00,0x00,0x00,0x00,0x08,0x42,0x02,0x00,  0x00,0x00,0x00,0x00,0x08,0x02,0x02,0x00,
0x00,0x00,0x00,0x00,0x08,0x00,0x02,0x00,  0x00,0x00,0x00,0x00,0x08,0x00,0x02,0x00,  0x00,0x20,0x3F,0x00,0x08,0x00,0x02,0x00,  0x00,0x20,0x7F,0x80,0x08,0x00,0x02,0x00,
0x00,0x20,0xE1,0x80,0x18,0x08,0x02,0x00,  0x00,0x21,0xC0,0x80,0x10,0x08,0x02,0x00,  0x00,0x21,0x81,0x80,0x10,0x3E,0x02,0x00,  0x01,0xFF,0xFF,0x80,0x10,0x3F,0xE2,0x00,
0x01,0xFF,0xFF,0x00,0x10,0x09,0xE2,0x00,  0x00,0x22,0x00,0x00,0x10,0x18,0x02,0x00,  0x00,0x26,0x00,0x00,0x10,0x11,0x02,0x00,  0x00,0x26,0x02,0x00,0x10,0x13,0x02,0x00,
0x00,0x66,0x03,0x00,0x10,0x1E,0x02,0x00,  0x00,0x66,0x01,0x80,0x10,0x1C,0x02,0x00,  0x00,0x66,0x00,0x80,0x10,0x00,0x02,0x00,  0x00,0xE2,0x00,0x80,0x10,0x00,0x02,0x00,
0x00,0xE3,0x01,0x80,0x10,0x00,0x02,0x00,  0x00,0xFB,0xC7,0x00,0x10,0x00,0x02,0x00,  0x00,0x3D,0xFF,0x00,0x10,0x10,0x02,0x00,  0x00,0x04,0x7C,0x00,0x10,0x90,0x02,0x00,
0x00,0x00,0x00,0x00,0x10,0x90,0x22,0x00,  0x00,0x00,0x00,0x00,0x10,0x90,0x22,0x00,  0x00,0x00,0x00,0x00,0x10,0x90,0x22,0x00,  0x00,0x00,0x00,0x00,0x10,0x90,0x62,0x00,
0x00,0x00,0x00,0x80,0x10,0x90,0x42,0x00,  0x00,0x08,0x00,0x80,0x10,0x90,0xC2,0x00,  0x00,0x08,0x00,0x80,0x10,0x91,0x82,0x00,  0x00,0x08,0x00,0x80,0x10,0x97,0x02,0x00,
0x00,0x08,0x00,0x80,0x10,0x9E,0x02,0x00,  0x00,0x08,0x00,0x80,0x10,0x18,0x06,0x00,  0x00,0x08,0x00,0x80,0x18,0x00,0x04,0x00,  0x00,0x08,0x00,0x80,0x0E,0x00,0x0C,0x00,
0x00,0x08,0x00,0x80,0x03,0x00,0x08,0x00,  0x01,0xFF,0xFF,0x80,0x00,0x80,0x78,0x00,  0x01,0xFF,0xFF,0x80,0x00,0x43,0x80,0x00,  0x00,0x08,0x00,0x80,0x01,0xF6,0x00,0x00,
0x00,0x08,0x00,0x80,0x01,0xFE,0x00,0x00,  0x00,0x08,0x00,0x80,0x00,0x54,0x00,0x00,  0x00,0x08,0x00,0x80,0x07,0xD6,0x00,0x00,  0x00,0x08,0x00,0x80,0x0C,0x03,0x00,0x00,
0x00,0x08,0x00,0x80,0x08,0x01,0x00,0x00,  0x00,0x08,0x00,0x80,0x08,0x00,0x80,0x00,  0x00,0x08,0x00,0x80,0x08,0x00,0x80,0x00,  0x00,0x00,0x00,0x80,0x09,0xF4,0x80,0x00,
0x00,0x00,0x00,0x00,0x0B,0x3C,0xC0,0x00,  0x00,0x00,0x00,0x00,0x0C,0x02,0xC0,0x00,  0x00,0x00,0x00,0x00,0x00,0x03,0x80,0x00,  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x80,0x01,0xC0,0x00,0x00,0x40,0x00,  0x00,0x87,0xFF,0xC0,0x00,0x00,0x00,0x00,  0x00,0x87,0xFF,0x80,0x00,0x20,0x00,0x00,  0x00,0x84,0x7C,0x80,0x00,0x58,0x00,0x00,
0x00,0xF5,0xF4,0x80,0x00,0x84,0x00,0x00,  0x00,0xFD,0xC4,0x80,0x01,0x03,0x00,0x00,  0x00,0x9C,0x44,0x80,0x01,0x00,0x80,0x00,  0x00,0x84,0x44,0x80,0x02,0x00,0x60,0x00,
0x01,0x84,0x44,0x80,0x04,0x00,0x10,0x00,  0x01,0x85,0xFF,0x80,0x04,0x70,0x08,0x00,  0x00,0x85,0xFF,0x80,0x08,0x60,0x08,0x00,  0x00,0x84,0x44,0x80,0x08,0x00,0x04,0x00,
0x00,0xFC,0x44,0x80,0x08,0x00,0x04,0x00,  0x00,0xFC,0x44,0x80,0x10,0x00,0x04,0x00,  0x00,0x84,0x44,0x80,0x10,0x00,0x22,0x00,  0x00,0x84,0x44,0x80,0x10,0x30,0x22,0x00,
0x00,0x84,0x44,0x80,0x11,0xF2,0x22,0x00,  0x00,0x84,0x00,0x80,0x21,0xC2,0x21,0x00,  0x00,0x00,0x00,0x00,0x20,0x42,0x23,0x00,  0x00,0x00,0x00,0x00,0x20,0x42,0x23,0x00,
0x00,0x00,0x00,0x00,0x21,0xFF,0xE2,0x00,  0x00,0x00,0x00,0x00,0x21,0xFF,0xE2,0x00,  0x00,0x00,0x00,0x00,0x40,0x42,0x22,0x00,  0x00,0x07,0xFF,0x80,0x40,0x42,0x22,0x00,
0x00,0xFF,0xFF,0x80,0xC0,0x42,0x22,0x00,  0x00,0xFE,0x01,0x80,0xC0,0x42,0x22,0x00,  0x00,0x00,0x00,0x01,0x40,0x40,0x21,0x00,  0x00,0x10,0x00,0x01,0x40,0x00,0x01,0x00,
0x00,0x10,0x0E,0x01,0x40,0x00,0x01,0x00,  0x00,0x10,0x1F,0x03,0x40,0x00,0x01,0x00,  0x00,0x10,0x31,0x82,0x40,0x20,0x01,0xC0,  0x00,0x10,0x20,0x82,0x40,0x23,0x81,0x60,
0x00,0x10,0x20,0x82,0x40,0x27,0xC1,0x20,  0x00,0x10,0x30,0x82,0x40,0x24,0x41,0x10,  0x00,0x10,0x30,0x82,0x40,0xA4,0x41,0x10,  0x00,0x10,0x33,0x82,0x40,0xE4,0x41,0x10,
0x00,0xFF,0xFF,0x81,0x40,0x74,0x41,0xB0,  0x00,0xFF,0xFF,0x01,0x40,0x3C,0x41,0x60,  0x00,0x10,0x0C,0x01,0x40,0x6C,0x41,0x00,  0x00,0x30,0x0E,0x01,0xC0,0x46,0x41,0x00,
0x00,0x30,0x06,0x00,0x40,0x02,0x41,0x00,  0x00,0x10,0x02,0x00,0x40,0x00,0x01,0x00,  0x00,0x00,0x00,0x00,0x40,0x00,0x01,0x00,  0x00,0x00,0x00,0x00,0x20,0x00,0x01,0x00,
0x00,0x00,0x00,0x00,0x20,0x00,0x01,0x00,  0x00,0x00,0x00,0x00,0x20,0x20,0x40,0x80,  0x00,0x00,0x00,0x00,0x20,0x21,0xC0,0x80,  0x00,0x00,0x00,0x00,0x20,0x2F,0x80,0x80,
0x00,0x00,0x00,0x00,0x60,0x7E,0x40,0x80,  0x00,0x00,0x00,0x00,0x40,0x70,0x40,0x80,  0x00,0x00,0x00,0x00,0x40,0x20,0x40,0x80,  0x00,0x00,0x00,0x00,0x40,0x20,0x40,0x80,
0x00,0x00,0x00,0x00,0x20,0x3F,0xC0,0x80,  0x00,0x00,0x00,0x00,0x20,0x7F,0x80,0x80,  0x00,0x00,0x00,0x00,0x20,0x70,0x00,0x80,  0x00,0x00,0x00,0x00,0x20,0x38,0x01,0x00,
0x00,0x00,0x00,0x00,0x20,0x08,0x01,0x00,  0x00,0x00,0x00,0x00,0x20,0x00,0x01,0x00,  0x00,0x00,0x00,0x00,0x20,0x00,0x02,0x00,  0x00,0x00,0x00,0x00,0x20,0x00,0x02,0x00,
0x00,0x00,0x00,0x00,0x20,0x01,0x82,0x00,  0x00,0x00,0x00,0x00,0x20,0x27,0x82,0x00,  0x00,0x00,0x00,0x00,0x20,0x3E,0x02,0x00,  0x00,0x00,0x00,0x00,0x20,0xF8,0xC4,0x00,
0x00,0x00,0x00,0x00,0x10,0xC1,0xE4,0x00,  0x00,0x00,0x00,0x00,0x10,0x41,0x24,0x00,  0x00,0x00,0x00,0x00,0x08,0x41,0x24,0x00,  0x00,0x00,0x00,0x00,0x08,0x4F,0x64,0x00,
0x00,0x00,0x00,0x00,0x04,0x5F,0xC8,0x00,  0x00,0x00,0x00,0x00,0x02,0x50,0xC8,0x00,  0x00,0x00,0x00,0x00,0x02,0x18,0x48,0x00,  0x00,0x00,0x00,0x00,0x01,0x08,0x48,0x00,
0x00,0x00,0x00,0x00,0x00,0x80,0x10,0x00,  0x00,0x00,0x00,0x00,0x00,0x80,0x20,0x00,  0x00,0x00,0x00,0x00,0x00,0x40,0x40,0x00,  0x00,0x00,0x00,0x00,0x00,0x40,0x80,0x00,
0x00,0x00,0x00,0x00,0x00,0x25,0x00,0x00,  0x00,0x00,0x00,0x00,0x00,0x73,0x00,0x00,  0x00,0x00,0x00,0x00,0x07,0x80,0x80,0x00,  0x00,0x00,0x00,0x00,0x18,0x00,0x60,0x00,
0x00,0x00,0x00,0x00,0x70,0x00,0x10,0x00,  0x00,0x00,0x00,0x00,0x48,0x18,0x08,0x00,  0x00,0x00,0x00,0x00,0xC8,0x33,0xFE,0x00,  0x00,0x00,0x00,0x00,0x88,0x60,0x0F,0x00
};

void readImage()
{
    printf("\37(f\1");     // rbg}bv`
    putchar(0);putchar(0);putchar(0);
    putchar(0);putchar(16);putchar(0);
    for(unsigned int inx = 0; inx < 512 * 8; inx++) {
        putchar(pgm_read_byte(&imageData[inx]));
    }
}

void dispImageAt(int x, int y, int rX, int dS)
{
    printf("\37(d\40");
    putchar(x & 0xFF);putchar(x >> 8);      // \ʒu X
    putchar(y);putchar(0);      //          Y
    putchar(0);                 // RAM
    putchar(rX & 0xFF);putchar(rX >> 8);putchar(0);   // RAM Address
    putchar(8);putchar(0);      // Y size (byte)
    putchar(0);putchar(0);      // X offset
    putchar(0);putchar(0);      // Y offset
    putchar(dS & 0xFF);putchar(dS >> 8);     // X size (pixel)
    putchar(64);putchar(0);     // Y size (pixel)
    putchar(1);                 // image
}
/*
unsigned char tragiData[] EEMEM =
{
//@gZS
// SIZE:W:128, H:32
0x1F,0xFF,0xFF,0xF8,  0x7F,0xFF,0xFF,0xFE,  0x70,0x00,0x00,0x0E,  0xE0,0x00,0x00,0x07,
0xC3,0xFF,0xFF,0xE3,  0xC3,0xFF,0xFF,0xE3,  0xC3,0xFF,0xFF,0xE3,  0xC3,0xFF,0xFF,0xE3,
0xC3,0x06,0x00,0x03,  0xC3,0x07,0x00,0x03,  0xC0,0x03,0x80,0x03,  0xC0,0x03,0xE0,0x03,
0xC0,0x03,0xF0,0x03,  0xC0,0x01,0xF8,0x03,  0xC1,0x8C,0xF8,0x03,  0xC1,0xCE,0xF8,0x23,
0xC1,0xCE,0x70,0x63,  0xC1,0xCE,0x00,0xE3,  0xC1,0xCE,0x01,0xC3,  0xC1,0xCE,0x03,0xC3,
0xC1,0xCE,0x07,0x83,  0xC1,0xCE,0x3F,0x83,  0xC1,0xCF,0xFF,0x03,  0xC1,0xCF,0xFE,0x03,
0xC1,0xCF,0xFC,0x03,  0xC3,0xDF,0xF8,0x03,  0xC3,0xDF,0xE0,0x03,  0xC0,0xDF,0x00,0x03,
0xC7,0x00,0x00,0x03,  0xC3,0x80,0x02,0x03,  0xC3,0xF0,0x07,0x83,  0xC1,0xF8,0x07,0xE3,
0xC0,0xFC,0x1F,0xE3,  0xC0,0xFE,0x1F,0xE3,  0xC0,0x7C,0x3F,0x83,  0xC0,0x18,0x7F,0x03,
0xC0,0x00,0xFE,0x03,  0xC0,0x03,0xFC,0x03,  0xC0,0x07,0xF8,0x03,  0xC0,0x0F,0xE0,0x03,
0xC0,0x7F,0x80,0x03,  0xC3,0xFE,0x00,0x03,  0xC1,0x40,0x00,0x03,  0xC2,0x10,0x02,0x03,
0xC3,0x1C,0x07,0x03,  0xC1,0x9E,0x07,0x83,  0xC1,0xCF,0x0F,0xE3,  0xC1,0xEF,0x9F,0xE3,
0xC1,0xF7,0x1F,0x83,  0xC0,0xF2,0x3F,0x03,  0xC2,0x60,0x7E,0x03,  0xC1,0x80,0xFC,0x03,
0xC5,0xC1,0xF8,0x03,  0xC3,0xC7,0xF0,0x03,  0xC3,0x9F,0xC0,0x63,  0xC1,0xFF,0x80,0x43,
0xC0,0xFC,0x00,0xC3,  0xC1,0x00,0x01,0x83,  0xC1,0xC0,0x07,0x83,  0xC1,0xC0,0x0F,0x03,
0xC1,0xC0,0x3F,0x03,  0xC1,0xC0,0xFE,0x03,  0xC1,0xC5,0xFC,0x03,  0xC1,0xDF,0xF8,0x03,
0xC1,0xFF,0xF0,0x03,  0xC3,0xFF,0xFE,0x03,  0xC3,0xFF,0x1F,0xC3,  0xC3,0xFE,0x1F,0xC3,
0xC1,0xE0,0x0F,0xE3,  0xC0,0x00,0x07,0xC3,  0xC0,0x01,0x01,0xC3,  0xC0,0x03,0x00,0x23,
0xC0,0x1F,0x00,0x43,  0xC3,0xFE,0x00,0xC3,  0xC3,0xFF,0x03,0x83,  0xC3,0xFB,0xC7,0x83,
0xC3,0xF3,0xDF,0x03,  0xC3,0xE1,0xFE,0x03,  0xC2,0xE1,0xFE,0x03,  0xC0,0xFF,0xFC,0x03,
0xC0,0xFF,0xF0,0x03,  0xC1,0xFF,0xE0,0x03,  0xC1,0xFF,0x80,0x03,  0xC0,0xFC,0x00,0x03,
0xC0,0x50,0xC0,0x03,  0xC0,0x38,0xF8,0x03,  0xC0,0x38,0xF8,0x03,  0xC0,0xB8,0xF0,0x83,
0xC7,0xFF,0xFF,0xE3,  0xC7,0xFF,0xFF,0xE3,  0xC7,0xFF,0xFF,0xE3,  0xC3,0xFF,0xFF,0xE3,
0xC2,0x79,0x88,0x23,  0xC0,0x7B,0x3C,0x63,  0xC0,0x5B,0xFC,0xC3,  0xC0,0x63,0xE1,0xC3,
0xC7,0xFF,0x7F,0xC3,  0xC7,0xFF,0x3F,0x83,  0xC3,0xFF,0x1F,0x03,  0xC3,0xFF,0x7F,0x83,
0xC3,0x63,0xFF,0xC3,  0xC0,0xE7,0xFF,0xE3,  0xC0,0xE7,0xF1,0xE3,  0xC0,0xE3,0xC1,0x83,
0xC0,0x18,0xC1,0x03,  0xC0,0x71,0x80,0x03,  0xC3,0xEF,0xFF,0xE3,  0xC3,0xFF,0xFF,0xE3,
0xC3,0xDF,0xFF,0xE3,  0xC1,0xBB,0xFF,0x03,  0xC1,0x3B,0xFF,0x03,  0xC2,0x3B,0xFC,0x03,
0xC3,0xFF,0xFF,0xE3,  0xC3,0xFF,0xFF,0xE3,  0xC3,0xFF,0xFF,0xE3,  0xC3,0xBB,0xFE,0x03,
0xC0,0xFF,0xFE,0x03,  0xC1,0xED,0xFF,0xE3,  0xC1,0xAD,0x0E,0xE3,  0xC1,0x8F,0xFF,0xE3,
0xC1,0x8F,0xFF,0xC3,  0xC3,0x9F,0xFF,0xC3,  0xC3,0x9C,0x00,0x03,  0xC1,0x9C,0x00,0x03,
0xE0,0x00,0x00,0x07,  0x70,0x00,0x00,0x0E,  0x7F,0xFF,0xFF,0xFE,  0x1F,0xFF,0xFF,0xF8
};

void readTragiData()
{
    printf("\37(f\1");     // rbg}bv`
    putchar(0);putchar(0);putchar(0);
    putchar(0);putchar(2);putchar(0);
    for(char inx = 0; inx < 128; inx++) {
        for(char iny = 0; iny < 4; iny++) {
            putchar(eeprom_read_byte(&tragiData[inx * 4 + iny]));
        }
    }
}

void dispTragiLogoAt(int x, int y, int rX, int dS)
{
    printf("\37(d\40");
    putchar(x & 0xFF);putchar(x >> 8);      // \ʒu X
    putchar(y);putchar(0);      //          Y
    putchar(0);                 // RAM
    putchar(rX & 0xFF);putchar(rX >> 8);putchar(0);   // RAM Address
    putchar(4);putchar(0);      // Y size (byte)
    putchar(0);putchar(0);      // X offset
    putchar(0);putchar(0);      // Y offset
    putchar(dS);putchar(0);     // X size (pixel)
    putchar(32);putchar(0);     // Y size (pixel)
    putchar(1);                 // image
}

void scrollTragiLogo()
{
    int x;
    dispTragiLogoAt(64, 16, 0, 128);
    _delay_ms(2000);
    x = 63;
    for(int inx = 0; inx < 256; inx++) {
        ledPort(inx >> 4);
        drawLine(0, 0, x, 16, x, 47);       // 1C
        x = inx + 64;
        if(x >= 256) x -= 256;
        dispTragiLogoAt(x, 16, 0, 128);        // 1hbg炵ĕ\
        if((inx > 64) && (inx < 192)) {     // EBn߂A
            dispTragiLogoAt(0, 16, (768 - inx * 4), inx - 64); // \
        } else {
            _delay_us(1500);
        }
        _delay_ms(10);
    }
    _delay_ms(2000);
}

void showMaikohan()
{
    drawLine(2, 1, 0, 0, 255, 63);  // Frame
    drawLine(2, 0, 3, 3, 252, 60);  // Inner
    drawDot(0, 0, 0);drawDot(0, 1, 0);drawDot(0, 0, 1);drawDot(1, 3, 3);
    drawDot(0, 255, 0);drawDot(0, 254, 0);drawDot(0, 255, 1);drawDot(1, 252, 3);
    drawDot(0, 0, 63);drawDot(0, 1, 63);drawDot(0, 0, 62);drawDot(1, 3, 60);
    drawDot(0, 255, 63);drawDot(0, 254, 63);drawDot(0, 255, 62);drawDot(1, 252, 60);
    ledPort(1);
    printf("\37(g\1\4");        // TCYݒ
    printAt( 8, 10, "");
    printAt(184, 10, "s");
    printf("\37(g\1\2");        // TCYݒ
    printAt(20, 44, "12:00");
    printAt(196, 44, "13:30");
    drawLine(2, 1, 80, 30, 176, 32);
    ledPort(2);
    _delay_ms(500);

    printf("\37(g\1\2");        // TCYݒ
    printAt(80, 8, "(gZ)");
    printAt(104, 38, "܂");
    printAt(272, 4, "gWX^Zp");
    printAt(272, 24, "PO");
    printAt(272, 44, "łB");
    ledPort(4);
    dispTragiLogoAt(356, 32, 0, 128);
    _delay_ms(2000);

    printf("\37(a\20");putchar(8);putchar(0);putchar(0);putchar(2);putchar(1);
    ledPort(8);
    _delay_ms(3000);
    ledPort(9);
    _delay_ms(3000);
    ledPort(10);
    _delay_ms(2000);
    ledPort(11);
    _delay_ms(3000);
}

*/



