/*

            ^OtBNX\

        Copyright 2009-2011 , Yoshi Hiroshi.

 */

#include <avr/io.h>
#include <avr/eeprom.h>
#include <util/delay.h>
#include <stdio.h>
#include <math.h>

unsigned char bitmapData[] EEMEM;

int par80PutByte(char c, FILE *stream);
FILE par80 = FDEV_SETUP_STREAM(par80PutByte, 0, _FDEV_SETUP_RW);

void par80Init()
{
    DDRB = 0xFF;
    DDRD = 0x60;
    PORTD = 0x20;   // WR:HIGH
    stdout = &par80;
    _delay_ms(1);
}

int par80PutByte(char c, FILE *stream)   // 1oCg̓]
{
    loop_until_bit_is_set(PIND, PD7);
    PORTB = c;
    PORTD &= ~_BV(PD5); // WR LOW
    PORTD |= _BV(PD5);  // WR HIGH
    //_delay_ms(100);
    return 0;
}

void ledPort(char val)
{
    printf("\37(p\20\1");    // PORT 1 OUT
    putchar(val);
}

void bitmapDispAt(int x, int y, int rX, int dS)
{
    printf("\37(d\40");
    putchar(x);putchar(0);      // \ʒu X
    putchar(y);putchar(0);      //          Y
    putchar(0);                 // RAM
    putchar(rX & 0xFF);putchar(rX >> 8);putchar(0);   // RAM Address
    putchar(4);putchar(0);      // Y size (byte)
    putchar(0);putchar(0);      // X offset
    putchar(0);putchar(0);      // Y offset
    putchar(dS);putchar(0);     // X size (pixel)
    putchar(32);putchar(0);     // Y size (pixel)
    putchar(1);                 // image
}

int main()
{
    int x;
    int y;

    CLKPR = _BV(CLKPCE);
    CLKPR = 0;
    par80Init();
    printf("\37(p\1\1\377");    // PORT 1 DDR

    printf("\37(f\1");     // rbg}bv`
    putchar(0);putchar(0);putchar(0);
    putchar(0);putchar(2);putchar(0);
    for(char inx = 0; inx < 128; inx++) {
        for(char iny = 0; iny < 4; iny++) {
            putchar(eeprom_read_byte(&bitmapData[inx * 4 + iny]));
        }
    }

    while(1) {

// ʂP
        printf("\14");              // CLEAR
        printf("\37(d\40");
        putchar(64);putchar(0);     // \ʒu X
        putchar(16);putchar(0);     //          Y
        putchar(0);                 // RAM
        putchar(0);putchar(0);putchar(0);   // RAM Address
        putchar(4);putchar(0);      // Y size (byte)
        putchar(0);putchar(0);      // X offset
        putchar(0);putchar(0);      // Y offset
        putchar(128);putchar(0);    // X size (pixel)
        putchar(32);putchar(0);     // Y size (pixel)
        putchar(1);                 // image
        _delay_ms(1000);

// ʂQ
        x = 63;
        for(int inx = 0; inx < 256; inx++) {
            ledPort(inx >> 4);
            printf("\37(d\21");         // C`
            putchar(0);                 // line
            putchar(0);                 // pen OFF
            putchar(x);putchar(0);      // start X
            putchar(16);putchar(0);     // start Y
            putchar(x);putchar(0);      // end X
            putchar(47);putchar(0);     // end Y
            x = inx + 64;
            if(x >= 256) x -= 256;
            bitmapDispAt(x, 16, 0, 128);
            if((inx > 64) && (inx < 192)) {
                bitmapDispAt(0, 16, (768 - inx * 4), inx - 64);
            }
            _delay_ms(10);
        }
        _delay_ms(3000);

// ʂR
        printf("\37(g\1\2");        // TCYݒ 
        printf("\37(g\2\1");        // 2@byte mode ON
        printf("\14");              // CLEAR
        ledPort(1);                 // PORT 1 OUT
        printf("悤uec̐EցI\n\r");
        _delay_ms(1000);
        ledPort(2);                 // PORT 1 OUT
        printf("g\n\r");
        _delay_ms(1000);
        ledPort(4);                 // PORT 1 OUT
        printf("OtBNX\n\r");
        _delay_ms(1000);
        ledPort(8);                 // PORT 1 OUT
        printf("ėpIOtB");
        for(int inx = 0; inx < 720; inx++) {    // ig
            double angle = 3.14 * inx / 120.0;
            x = (sin(angle) * inx / 720.0) * 32 + 223;
            y = (cos(angle) * inx / 720.0) * 32 + 32;
            printf("\37(d\20");     // rbg
            putchar(1);             // ON
            putchar(x & 0xFF);
            putchar(0);
            putchar(y & 0xFF);
            putchar(0);
            ledPort(1 << (((char)inx >> 4) & 0x03));
        }
        for(int inx = 0; inx < 720; inx++) {    // ig
            double angle = 3.14 * inx / 120.0;
            x = (sin(angle) * inx / 720.0) * 32 + 223;
            y = (cos(angle) * inx / 720.0) * 32 + 32;
            printf("\37(d\20");     // rbg
            putchar(0);             // OFF
            putchar(x & 0xFF);
            putchar(0);
            putchar(y & 0xFF);
            putchar(0);
            ledPort(1 << (((char)inx >> 4) & 0x03));
        }
        _delay_ms(2000);

// ʂS
        printf("\14");              // CLEAR
        ledPort(1);                 // PORT 1 OUT
        printf("\37(g\1\1");        // 6x8
        printf("Hello Vacuum Fluorescent Display GU256X64C\n\r");
        _delay_ms(500);
        printf("\37(g\1\2");        // TCYݒ 8x16
        printf("\37X\23");          // 37.5%
        ledPort(3);                 // PORT 1 OUT
        printf("Big");
        _delay_ms(500);
        printf("\37(g\1\3");        // TCYݒ 12x24
        printf("\37X\26");          // 75%
        ledPort(7);                 // PORT 1 OUT
        printf("  Bigger\n\r");
        _delay_ms(500);
        printf("\37(g\1\4");        // TCYݒ 16x32
        printf("\37X\30");          // 100%
        ledPort(15);                // PORT 1 OUT
        printf("        Biggest ");
        _delay_ms(1000);
    }
}

unsigned char bitmapData[] EEMEM =
{
// SIZE:W:128, H:32
0x1F,0xFF,0xFF,0xF8,  0x7F,0xFF,0xFF,0xFE,  0x70,0x00,0x00,0x0E,  0xE0,0x00,0x00,0x07,
0xC3,0xFF,0xFF,0xE3,  0xC3,0xFF,0xFF,0xE3,  0xC3,0xFF,0xFF,0xE3,  0xC3,0xFF,0xFF,0xE3,
0xC3,0x06,0x00,0x03,  0xC3,0x07,0x00,0x03,  0xC0,0x03,0x80,0x03,  0xC0,0x03,0xE0,0x03,
0xC0,0x03,0xF0,0x03,  0xC0,0x01,0xF8,0x03,  0xC1,0x8C,0xF8,0x03,  0xC1,0xCE,0xF8,0x23,
0xC1,0xCE,0x70,0x63,  0xC1,0xCE,0x00,0xE3,  0xC1,0xCE,0x01,0xC3,  0xC1,0xCE,0x03,0xC3,
0xC1,0xCE,0x07,0x83,  0xC1,0xCE,0x3F,0x83,  0xC1,0xCF,0xFF,0x03,  0xC1,0xCF,0xFE,0x03,
0xC1,0xCF,0xFC,0x03,  0xC3,0xDF,0xF8,0x03,  0xC3,0xDF,0xE0,0x03,  0xC0,0xDF,0x00,0x03,
0xC7,0x00,0x00,0x03,  0xC3,0x80,0x02,0x03,  0xC3,0xF0,0x07,0x83,  0xC1,0xF8,0x07,0xE3,
0xC0,0xFC,0x1F,0xE3,  0xC0,0xFE,0x1F,0xE3,  0xC0,0x7C,0x3F,0x83,  0xC0,0x18,0x7F,0x03,
0xC0,0x00,0xFE,0x03,  0xC0,0x03,0xFC,0x03,  0xC0,0x07,0xF8,0x03,  0xC0,0x0F,0xE0,0x03,
0xC0,0x7F,0x80,0x03,  0xC3,0xFE,0x00,0x03,  0xC1,0x40,0x00,0x03,  0xC2,0x10,0x02,0x03,
0xC3,0x1C,0x07,0x03,  0xC1,0x9E,0x07,0x83,  0xC1,0xCF,0x0F,0xE3,  0xC1,0xEF,0x9F,0xE3,
0xC1,0xF7,0x1F,0x83,  0xC0,0xF2,0x3F,0x03,  0xC2,0x60,0x7E,0x03,  0xC1,0x80,0xFC,0x03,
0xC5,0xC1,0xF8,0x03,  0xC3,0xC7,0xF0,0x03,  0xC3,0x9F,0xC0,0x63,  0xC1,0xFF,0x80,0x43,
0xC0,0xFC,0x00,0xC3,  0xC1,0x00,0x01,0x83,  0xC1,0xC0,0x07,0x83,  0xC1,0xC0,0x0F,0x03,
0xC1,0xC0,0x3F,0x03,  0xC1,0xC0,0xFE,0x03,  0xC1,0xC5,0xFC,0x03,  0xC1,0xDF,0xF8,0x03,
0xC1,0xFF,0xF0,0x03,  0xC3,0xFF,0xFE,0x03,  0xC3,0xFF,0x1F,0xC3,  0xC3,0xFE,0x1F,0xC3,
0xC1,0xE0,0x0F,0xE3,  0xC0,0x00,0x07,0xC3,  0xC0,0x01,0x01,0xC3,  0xC0,0x03,0x00,0x23,
0xC0,0x1F,0x00,0x43,  0xC3,0xFE,0x00,0xC3,  0xC3,0xFF,0x03,0x83,  0xC3,0xFB,0xC7,0x83,
0xC3,0xF3,0xDF,0x03,  0xC3,0xE1,0xFE,0x03,  0xC2,0xE1,0xFE,0x03,  0xC0,0xFF,0xFC,0x03,
0xC0,0xFF,0xF0,0x03,  0xC1,0xFF,0xE0,0x03,  0xC1,0xFF,0x80,0x03,  0xC0,0xFC,0x00,0x03,
0xC0,0x50,0xC0,0x03,  0xC0,0x38,0xF8,0x03,  0xC0,0x38,0xF8,0x03,  0xC0,0xB8,0xF0,0x83,
0xC7,0xFF,0xFF,0xE3,  0xC7,0xFF,0xFF,0xE3,  0xC7,0xFF,0xFF,0xE3,  0xC3,0xFF,0xFF,0xE3,
0xC2,0x79,0x88,0x23,  0xC0,0x7B,0x3C,0x63,  0xC0,0x5B,0xFC,0xC3,  0xC0,0x63,0xE1,0xC3,
0xC7,0xFF,0x7F,0xC3,  0xC7,0xFF,0x3F,0x83,  0xC3,0xFF,0x1F,0x03,  0xC3,0xFF,0x7F,0x83,
0xC3,0x63,0xFF,0xC3,  0xC0,0xE7,0xFF,0xE3,  0xC0,0xE7,0xF1,0xE3,  0xC0,0xE3,0xC1,0x83,
0xC0,0x18,0xC1,0x03,  0xC0,0x71,0x80,0x03,  0xC3,0xEF,0xFF,0xE3,  0xC3,0xFF,0xFF,0xE3,
0xC3,0xDF,0xFF,0xE3,  0xC1,0xBB,0xFF,0x03,  0xC1,0x3B,0xFF,0x03,  0xC2,0x3B,0xFC,0x03,
0xC3,0xFF,0xFF,0xE3,  0xC3,0xFF,0xFF,0xE3,  0xC3,0xFF,0xFF,0xE3,  0xC3,0xBB,0xFE,0x03,
0xC0,0xFF,0xFE,0x03,  0xC1,0xED,0xFF,0xE3,  0xC1,0xAD,0x0E,0xE3,  0xC1,0x8F,0xFF,0xE3,
0xC1,0x8F,0xFF,0xC3,  0xC3,0x9F,0xFF,0xC3,  0xC3,0x9C,0x00,0x03,  0xC1,0x9C,0x00,0x03,
0xE0,0x00,0x00,0x07,  0x70,0x00,0x00,0x0E,  0x7F,0xFF,0xFF,0xFE,  0x1F,0xFF,0xFF,0xF8
};

